﻿XIncludeFile "DS18B20_Module.pbi"

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  XIncludeFile "Form_Win.pbf"
  #PortName = "COM"
CompilerElse
  XIncludeFile "Form_Lin.pbf"
  #PortName = "/dev/ttyS"
CompilerEndIf

UseModule DS18B20

Procedure Thread(*x)
  Shared OpenPort_Flag
  Protected Info.DS_DataByte, x.w
  
  Repeat
    
    If GetThermo(@Info)
      
      If GetCRC(@Info, 8)=Info\CRC
        SetGadgetText(#Text_Status, "Порт открыт")
        x=(Info\H_Termo<<8)|Info\L_Termo
        SetGadgetText(#String_Thermo, StrF(x/16, 1)+" °C")
      Else
        SetGadgetText(#Text_Status, "Ошибка CRC")
      EndIf
      
    Else
      x=GetLastErr()
      If x<>#DS_Err_OK
        SetGadgetText(#Text_Status, getLastErr_String(x))
        SetGadgetText(#String_Thermo, "")
      EndIf
    EndIf
    
    Delay(200)
  ForEver
EndProcedure

Procedure ReadSetting()
  OpenPreferences("Setting.ini")
  Port.s=ReadPreferenceString("Port", "")
  ClosePreferences()
  If Port<>""
    SetGadgetText(#Combo_Ports, Port)
  EndIf
EndProcedure

Procedure WriteSetting()
  CreatePreferences("Setting.ini")
  WritePreferenceString("Port", GetGadgetText(#Combo_Ports))
  ClosePreferences()
EndProcedure

Procedure EnumPorts()
  ClearGadgetItems(#Combo_Ports)
  For i=0 To 10
    If OpenSerialPort(2, #PortName+i, 9600, #PB_SerialPort_NoParity,
                      8, 1, #PB_SerialPort_NoHandshake, 255, 255)
      AddGadgetItem(#Combo_Ports, -1, #PortName+i)
      CloseSerialPort(2)
    EndIf
  Next
EndProcedure

Procedure SelectPort()
  Shared OpenPort_Flag
  
  Port.s = GetGadgetText(#Combo_Ports)
  
  ClosePort()
  OpenPort_Flag = #False
  
  If Port<>""
    If OpenPort(Port)
      OpenPort_Flag = #True
      SetGadgetText(#Text_Status, "Порт открыт")
    Else
      SetGadgetText(#Text_Status, GetLastErr_String(GetLastErr()))
      SetGadgetText(#String_Thermo, "")
    EndIf
  EndIf
  
EndProcedure

SetCurrentDirectory(GetPathPart(ProgramFilename()))

OpenWinMain()
EnumPorts()
ReadSetting()
SelectPort()

ThreadNum = CreateThread(@Thread(), 0)
BindGadgetEvent(#Combo_Ports, @SelectPort(), #PB_EventType_Change)
HideWindow(#WinMain, #False)

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
KillThread(ThreadNum)
WriteSetting()
ClosePort()
; IDE Options = PureBasic 5.21 LTS Beta 3 (Windows - x86)
; CursorPosition = 14
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP